# Kubernetes storage rules
groups:
- name: Kubernetes Storage
  rules:
  - alert: k8s-Persistent_Volume_Usage_Critical
    expr: (kubelet_volume_stats_used_bytes / kubelet_volume_stats_capacity_bytes * 100 > 80) and on (namespace) info:sylva_namespace
    for: 5m
    labels:
      severity: 'warning'
      sylva_alert: 'true'
      type: 'k8s'
    annotations:
      description: 'PersistentVolumeClaim {{ $labels.namespace }}/{{ $labels.persistentvolumeclaim }} in cluster "{{ $labels.cluster }}" is over 80% used. Value: {{ printf "%0.2f" $value }}%'
      runbook_url: ''
      summary: 'Persistent Volume usage is Critical'

  - alert: k8s-Persistent_Volume_Full_in_4_days
    expr: ((kubelet_volume_stats_available_bytes / kubelet_volume_stats_capacity_bytes ) * 100 < 15 and predict_linear(kubelet_volume_stats_available_bytes[6h], 4 * 24 * 3600) < 0) and on (namespace) info:sylva_namespace
    for: 5m
    labels:
      severity: 'warning'
      sylva_alert: 'true'
      type: 'k8s'
    annotations:
      description: 'PersistentVolumeClaim {{ $labels.namespace }}/{{ $labels.persistentvolumeclaim }} in cluster "{{ $labels.cluster }}" will fill up in 4 days at the current rate of utilization. Value: {{ printf "%0.2f" $value }}% available'
      runbook_url: ''
      summary: 'Persistent Volume will fill up in 4 days'

  - alert: k8s-Persistent_Volume_Errors
    expr: (kube_persistentvolume_status_phase{phase=~"Failed|Pending"} > 0) and on (namespace) info:sylva_namespace
    for: 5m
    labels:
      severity: 'warning'
      sylva_alert: 'true'
      type: 'k8s'
    annotations:
      description: 'PersistentVolume "{{ $labels.persistentvolume }}" in cluster "{{ $labels.cluster }}" has status "{{ $labels.phase }}"'
      runbook_url: ''
      summary: 'Persistent Volume in bad state'

  - alert: k8s-Orphan_Persistent_Volume_Claim
    expr: ((kube_persistentvolumeclaim_info) unless on(persistentvolumeclaim) (kube_pod_spec_volumes_persistentvolumeclaims_info)) and on (namespace) info:sylva_namespace
    for: 3h
    labels:
      severity: 'warning'
      sylva_alert: 'true'
      type: 'k8s'
    annotations:
      description: 'PersistentVolumeClaim {{ $labels.namespace }}/{{ $labels.persistentvolumeclaim }} in cluster "{{ $labels.cluster }}" is not used by any pod'
      runbook_url: ''
      summary: 'Persistent Volume Claim is Orphan'

